<template>
  <div class="lots-container">
    <div class="lots-header">
      <ObAlert
        v-if="isTenderEditable"
        icon="info"
      >
        Для увеличения шанса на победу в тендере укажите значения "Ставок" и
        "Гарантируемых объемов" (при наличии столбца) в таблице справа.
        <span class="icon checked lots-alert-icon" />
      </ObAlert>

      <ObAlert
        v-else-if="isShowWelcomeAlert"
        text="Чтобы сделать ставки по лотам, нажмите кнопку «Участвовать»"
        icon="info"
      />

      <div :class="[ 'lots-filter', { 'centered': isFilterHidden } ]">
        <div
          v-if="!isFilterHidden && lotsFilters"
          class="row lots-filter__fields"
        >
          <div
            v-for="filter in lotsFilters"
            :key="filter.headerUuid"
            class="col-lg-2 col-md-3 col-xs-3"
          >
            <ObInput
              v-if="filter.valueType === 'TEXT'"
              :label="filter.title"
              placeholder="Выберите"
              v-model="filter.value"
              data-qa="from"
              @input="filterTable"
            />

            <ObSelect
              v-else-if="filter.valueType === 'CHECKLIST'"
              :label="filter.title"
              placeholder="Выберите"
              :items="vehicleTypeItems"
              v-model="filter.value"
              data-qa="vehicleType"
              @selected="filterTable"
            />
          </div>
        </div>

        <button
          type="button"
          class="lots-filter__toggle"
          data-qa="btnToggleFilter"
          @click="toggleFilter"
        >
          <template v-if="!isFilterHidden">
            Скрыть фильтр <span class="icon chevron-up lots-filter__toggle-icon" />
          </template>

          <template v-else>
            Развернуть фильтр <span class="icon chevron-down lots-filter__toggle-icon" />
          </template>
        </button>
      </div>
    </div>

    <ObTable
      ref="lotsTable"
      :key="tableKey"
      :functional-panel="true"
      :columns="carrierColumns"
      :show-add-button="false"
      :show-edit="false"
      :options-save-row="optionsTableSaveItem"
      :is-functional-group="false"
      :is-functional-sort="false"
      :remoteOpt="{
        method: fetchLots,
        contentKey: 'lots'
      }"
      class="lots-table"
      data-qa="lotsTable"
      @on-load-list="checkFieldsFilling"
    >
      <template slot="extraFuncToPanel">
        <ObMenuDropdown
          :items="excelDropdownItems"
          icon="excel"
        />
      </template>

      <template slot="table-row-check" slot-scope="{ data }">
        <span
          v-if="getCheckedIcon(data.item)"
          class="icon checked lots-icon lots-icon-checked"
        />
      </template>

      <template slot="table-row-comment" slot-scope="{ data }">
        <ObTooltip v-if="getComment(data.item)" :content="getComment(data.item)">
          <span class="icon event lots-icon lots-icon-comment" />
        </ObTooltip>
      </template>
    </ObTable>

    <ObModal
      ref="importFromExcelModal"
      title="Заполнение таблицы лотов в Excel"
      cancel-text="Отменить"
      size="medium"
      data-qa="importFromExcelModal"
    >
      <ModalImportFromExcel
        @close="closeImport"
        :tender-uuid="tenderInfo.uuid"
        :tender-number="tenderInfo.number"
        :request-uuid="tenderInfo.requestUuid"
      />
    </ObModal>

    <SuccessExport
      ref="successExportModal"
      :data-source="exportResult"
    />
  </div>
</template>

<script>
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObSelect from 'common-components/src/obComponents/obSelect'
  import ObTable from 'common-components/src/obComponents/obTable'
  import ObTooltip from 'common-components/src/obComponents/obTooltip'
  import ObAlert from 'common-components/src/obComponents/obAlert'
  import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'
  import ObModal from 'common-components/src/obComponents/obModal'

  import ModalImportFromExcel from '../../../modal/importExcel'
  import LotsTableMixin from '../mixins/lots-table'
  import ExportExcel from '../mixins/export-excel'
  import api from '@/api'

  export default {
    name: 'tender-tab-carrier-lots',
    components: {
      ObInput,
      ObSelect,
      ObTooltip,
      ObTable,
      ObAlert,
      ObMenuDropdown,
      ObModal,
      ModalImportFromExcel
    },
    mixins: [
      LotsTableMixin,
      ExportExcel
    ],
    data () {
      return {
        tableKey: 1, // Using to update editable table fields after import
        userType: 'carrier',
        isShowWelcomeAlert: false,
        isTenderEditable: false,
        isFilterHidden: false,
        isTenderAccepted: false,
        selectedData: {},
        fieldsInfo: {},
        isSomePriceFilled: false
      }
    },
    created () {
      this.isFilterHidden = ~~localStorage.getItem('isLotsFilterHidden') || false

      this.isShowWelcomeAlert = this.tenderInfo.participationStatus === 'VIEWED' && this.tenderInfo.status === 'HELD'
      this.isTenderEditable = this.tenderInfo.participationStatus === 'DRAFT' && this.tenderInfo.status === 'HELD'
      this.isTenderAccepted = this.tenderInfo.participationStatus !== 'VIEWED'
    },
    computed: {
      ...mapGetters({
        tender: 'tenders/tender',
      }),
      vehicleTypeItems () {
        const options = [{
          uuid: 'all',
          title: 'Все'
        }]

        if (!this.checklists.headers) {
          return options
        }

        return options.concat(this.checklists.headers.find((checklist) => {
          return checklist.uuid === this.lotsFilters.find((filter) => {
            return filter.code === 'vehicle_type'
          }).headerUuid
        }).options)
      },
      isAnyLotChecked () {
        if (!this.lotsData.lots) {
          return false
        }

        for (let i = 0; i < this.lotsData.lots.length; i++) {
          let allFieldsIsFilled = true

          for (let j = 0; j < this.lotsData.lots[i].headers.length; j++) {
            const header = this.lotsData.lots[i].headers[j]

            if (!header.isDisabled && !header.value) {
              allFieldsIsFilled = false
            }
          }

          if (allFieldsIsFilled) {
            return true
          }
        }

        return false
      },
      isAnyLotHaveComment () {
        if (!this.lotsData.lots) {
          return false
        }

        return this.lotsData.lots.find((lot) => {
          const commentColumn = lot.headers.find((header) => {
            return header.code === 'comment'
          })

          if (commentColumn) {
            return commentColumn.value
          } else {
            return false
          }
        })
      },
      carrierColumns () {
        if (this.isTenderAccepted) {
          const additionalColumns = []

          if (this.isAnyLotChecked) {
            additionalColumns.push({ slotName: 'table-row-check', width: 60, sortDisable: true })
          }

          if (this.isAnyLotHaveComment) {
            additionalColumns.push({ slotName: 'table-row-comment', width: 60, sortDisable: true })
          }

          return additionalColumns.concat(this.columns)
        } else {
          return this.columns
        }
      },
      excelDropdownItems () {
        const items = [
          {
            title: 'Выгрузить заполненные данные в Excel...',
            method: this.exportToExcel
          }
        ]

        if (this.isTenderEditable) {
          items.unshift({
            title: 'Заполнить таблицу лотов в Excel...',
            method: this.showImportExcelModal
          })
        }

        return items
      }
    },
    methods: {
      toggleFilter () {
        this.isFilterHidden = !this.isFilterHidden

        localStorage.setItem('isLotsFilterHidden', Number(this.isFilterHidden))
      },
      filterTable () {
        this.$refs.lotsTable.loadData({ init: true })
      },
      async onSave (data, reloadTable = true, types = this.initialFieldsTypes) {
        // If 'consent_desired_rate' is exists and checked, put 'desired_rate'
        // value to the 'price' field, on the other side if 'consent_desired_rate'
        // is exists and isn't checked, set 'price' field value to 'null'
        if (this.fieldsInfo['consent_desired_rate']) {
          const isConsentDesireRate = data[this.fieldsInfo['consent_desired_rate']]

          data[this.fieldsInfo['price']] = isConsentDesireRate ? data[this.fieldsInfo['desired_rate']] : null

          reloadTable = true
        }

        const payload = {
          tenderUuid: this.tenderInfo.uuid,
          lots: [{
            uuid: this.selectedData.uuid,
            headers: this.getLotValues(data, types)
          }]
        }

        try {
          await api.tenders.saveDraftByCarrier(this.tender.offers[0], payload)
          await this.updateTenderLots()

          if (reloadTable) {
            this.$refs.lotsTable.loadData({ init: true })
          }

          this.$notification({
            type: 'snackbars',
            message: 'Лот успешно отредактирован'
          })

          this.checkFieldsFilling()
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка редактирования лота'
          })
        }
      },
      checkFieldsFilling () {
        this.isSomePriceFilled = this.$refs.lotsTable?.localItems.some(item => item[this.fieldsInfo['price']])
      },
      getCheckedIcon (data) {
        if (!this.isTenderAccepted || !this.lotsData.lots.length) {
          return false
        }

        for (let i = 0; i < this.lotsData.lots[0].headers.length; i++) {
          const header = this.lotsData.lots[0].headers[i]

          if (header.isDisabled) {
            continue
          }

          if (!data[header.uuid]) {
            return false
          }
        }

        return true
      },
      getComment (data) {
        const commentColumn = this.columns.find((column) => {
          return column.code === 'comment'
        })

        if (!commentColumn) {
          return false
        }

        return data[commentColumn.key]
      },
      showImportExcelModal () {
        this.$refs.importFromExcelModal.open()
      },
      async closeImport () {
        this.$refs.lotsTable.loadData({ init: true })
        this.tableKey++ // Update editable table fields

        await this.updateTenderLots()

        this.$refs.importFromExcelModal.close()
      },
      async exportToExcel () {
        this.exportResult = await api.tendersExcels.RFQLots(this.tenderInfo.uuid, this.tenderInfo.requestUuid)
      }
    }
  };
</script>

<style lang="scss" scoped>
  @import '~common-components/src/assets/style/ob-style';
  @import '~common-components/src/static/css/variables';

  .lots-header {
    padding: 20px;
  }

  /deep/ .lots-alert-icon {
    color: $color-green-light;
  }

  .lots-filter {
    display: flex;
    align-items: center;

    &.centered {
      justify-content: center;
    }

    &__fields {
      flex-grow: 1;
    }

    &__toggle {
      color: $cobalt;
      font-size: 12px;
      text-decoration: none;
      background: none;
      border: none;
      cursor: pointer;
      display: flex;
      align-items: center;
      justify-self: flex-end;
    }

    &__toggle-icon {
      margin-left: 11px;
      font-size: 14px;
      font-weight: 600;
    }
  }

  .lots-icon {
    margin: auto;
    font-size: 16px;
  }

  .lots-table {
    border-top: 1px solid $lavender;
  }

  .lots-icon-comment {
    color: $cobalt;
  }

  .lots-icon-checked {
    color: $caribbean-green;
  }

  ::v-deep {
    .text-gray {
      color: $color-grey-span;
    }

    .table-header-required {
      color: $color-error;
      padding-left: 3px;
      font-size: 11px;

      &.disabled {
        color: $color-text-base;
      }
    }
  }
</style>
